package jogo;

import java.awt.Graphics2D;
import java.awt.Image;

/**
 *
 * @author renato
 */
public class Bomba extends Elemento {

    private Image bomba; // imagem da bomba
    private Image explosao; // imagem da explosao
    private boolean bombaViva; // indica se a bomba ainda nao explodiu
    private int tempoDeVidaDaBomba; // indica o tempo que bomba vai demorar para explodir
    private boolean explodida;
    private boolean explodindo; // indica que a bomba esta' explodindo
    private int tempoDeExplosao; // indica o tempo que ira' demorar a explosao
    private int bX; // coordenada X da bomba
    private int bY; // coordenada Y da bomba
    private int tamanhoExplosao;
    private int[] explosaoLados = {0, 0, 0, 0};
    private Jogador jogador = new Jogador();

    public Bomba(boolean bombaViva, int tempoDeVidaDaBomba, boolean explodindo, int tempoDeExplosao, int bX, 
            int bY, JogoTimer p, String imagemNome, int mx, int my, int tamanhoExplosao, Jogador jogador) {
        super(p, imagemNome, mx, my);
        this.bomba = this.carregarImagem("bomba.png");
        this.explosao = this.carregarImagem("explosao.png");
        this.bombaViva = bombaViva;
        this.tempoDeVidaDaBomba = tempoDeVidaDaBomba;
        this.explodindo = explodindo;
        this.tempoDeExplosao = tempoDeExplosao;
        this.bX = bX;
        this.bY = bY;
        this.tamanhoExplosao = tamanhoExplosao;
        this.explodida = false;
        this.jogador = jogador;
    }

    public void verificaJogador(int linha, int coluna) {
        if (linha == jogo.jog1.matLinha && coluna == jogo.jog1.matColuna && !jogo.jog1.imortal) {
            jogo.jog1.matColuna = 1;
            jogo.jog1.matLinha = 1;
            jogo.jog1.posX = jogo.jog1.matColuna * 40;
            jogo.jog1.posY = jogo.jog1.matLinha * 40;
            jogo.cenario[linha][coluna] = 2;
            jogo.jog1.vidas--;
            jogo.jog1.imortal = true;
        } else if (linha == jogo.jog2.matLinha && coluna == jogo.jog2.matColuna && !jogo.jog2.imortal) {
            jogo.jog2.matColuna = 15;
            jogo.jog2.matLinha = 9;
            jogo.jog2.posX = jogo.jog2.matColuna * 40;
            jogo.jog2.posY = jogo.jog2.matLinha * 40;
            jogo.cenario[linha][coluna] = 2;
            jogo.jog2.vidas--;
            jogo.jog2.imortal = true;
        }

    }

    public void destruirBloco(int linha, int coluna) {
        if (jogo.verificaBloco(linha, coluna) == 1) {
            double random = Math.random();
            if (Math.random() < 0.40) {
                if (random < 0.4) {
                    jogo.cenario[linha][coluna] = 10;
                } else if (random < 0.8) {
                    jogo.cenario[linha][coluna] = 11;
                } else {
                    jogo.cenario[linha][coluna] = 12;
                }
            } else {
                jogo.cenario[linha][coluna] = 2;
            }
        } else if (jogo.verificaBloco(linha, coluna) == 3) {
            for (Bomba b : jogador.getBombas()) {
                if (b.matLinha == linha && b.matColuna == coluna) {
                    b.setTempoDeVidaDaBomba(0);
                }
            }
        } else jogo.cenario[linha][coluna] = 2;
    }

    public void verificaBarreira() {
        for (int i = 0; i < 4; i++) {
            switch (i) {
                //cima
                case 0:
                    for (int j = 1; j <= tamanhoExplosao; j++) {
                        if (matLinha - j > 0 && matLinha - j < 11) {
                            if (jogo.cenario[matLinha - j][matColuna] == 2) {
                                explosaoLados[i]++;
                            } else {
                                if (jogo.cenario[matLinha - j][matColuna] == 0) {
                                    break;
                                }
                                if (jogo.isDestrutivel(matLinha - j, matColuna)) {
                                    explosaoLados[i]++;
                                    destruirBloco(matLinha - j, matColuna);
                                    break;
                                }
                            }
                        }
                    }
                    break;
                //direita
                case 1:
                    for (int j = 1; j <= tamanhoExplosao; j++) {
                        if (matColuna + j > 0 && matColuna + j < 17) {
                            if (jogo.cenario[matLinha][matColuna + j] == 2) {
                                explosaoLados[i]++;
                            } else {
                                if (jogo.cenario[matLinha][matColuna + j] == 0) {
                                    break;
                                }
                                if (jogo.isDestrutivel(matLinha, matColuna + j)) {
                                    explosaoLados[i]++;
                                    destruirBloco(matLinha, matColuna + j);
                                    break;
                                }
                            }
                        }
                    }
                    break;
                //baixo
                case 2:
                    for (int j = 1; j <= tamanhoExplosao; j++) {
                        if (matLinha + j > 0 && matLinha + j < 11) {
                            if (jogo.cenario[matLinha + j][matColuna] == 2) {
                                explosaoLados[i]++;
                            } else {
                                if (jogo.cenario[matLinha + j][matColuna] == 0) {
                                    break;
                                }
                                if (jogo.isDestrutivel(matLinha + j, matColuna)) {
                                    explosaoLados[i]++;
                                    destruirBloco(matLinha + j, matColuna);
                                    break;
                                }
                            }
                        }
                    }
                    break;
                //esquerda
                case 3:
                    for (int j = 1; j <= tamanhoExplosao; j++) {
                        if (matColuna - j > 0 && matColuna - j < 17) {
                            if (jogo.cenario[matLinha][matColuna - j] == 2) {
                                explosaoLados[i]++;
                            } else {
                                if (jogo.cenario[matLinha][matColuna - j] == 0) {
                                    break;
                                }
                                if (jogo.isDestrutivel(matLinha, matColuna - j)) {
                                    explosaoLados[i]++;
                                    destruirBloco(matLinha, matColuna - j);
                                    break;
                                }
                            }
                        }
                    }
                    break;
            }
        }
    }

    @Override
    public void atualizar() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void desenhar(Graphics2D g) {
        if (bombaViva) {
            g.drawImage(bomba, bX, bY, this.jogo);
            if (tempoDeVidaDaBomba <= 0) {
                bombaViva = false;
                explodindo = true;
                tempoDeExplosao = velocidade * 2;
                verificaBarreira();
            }
        }

        int linha = 0;
        int coluna = 0;

        if (explodindo) {
            jogo.cenario[matLinha][matColuna] = 2;
            g.drawImage(explosao, matColuna * jogo.larguraBloco, matLinha * jogo.larguraBloco, jogo);
            verificaJogador(matLinha, matColuna);
            for (int direcao = 0; direcao < 4; direcao++) {
                for (int casas = 0; casas < explosaoLados[direcao]; casas++) {
                    switch (direcao) {
                        //cima
                        case 0:
                            linha = matLinha - 1;
                            coluna = matColuna;
                            verificaJogador(linha - casas, coluna);
                            g.drawImage(explosao, coluna * jogo.larguraBloco, (linha - casas) * jogo.larguraBloco, jogo);
                            break;
                        //direita
                        case 1:
                            linha = matLinha;
                            coluna = matColuna + 1;
                            verificaJogador(linha, coluna + casas);
                            g.drawImage(explosao, (coluna + casas) * jogo.larguraBloco, linha * jogo.larguraBloco, jogo);
                            break;
                        //baixo
                        case 2:
                            linha = matLinha + 1;
                            coluna = matColuna;
                            verificaJogador(linha + casas, coluna);
                            g.drawImage(explosao, coluna * jogo.larguraBloco, (linha + casas) * jogo.larguraBloco, jogo);
                            break;
                        //esquerda
                        case 3:
                            linha = matLinha;
                            coluna = matColuna - 1;
                            verificaJogador(linha, coluna - casas);
                            g.drawImage(explosao, (coluna - casas) * jogo.larguraBloco, linha * jogo.larguraBloco, jogo);
                            break;
                    }
                }
                if (tempoDeExplosao <= 0) {
                    explodindo = false;
                    explodida = true;
                    jogo.cenario[matLinha][matColuna] = 2;
                }
            }

        }
    }

    int getbX() {
        return bX;
    }

    public void setbX(int bX) {
        this.bX = bX;
    }

    public int getbY() {
        return bY;
    }

    public void setbY(int bY) {
        this.bY = bY;
    }

    public Image getBomba() {
        return bomba;
    }

    public void setBomba(Image bomba) {
        this.bomba = bomba;
    }

    public boolean isBombaViva() {
        return bombaViva;
    }

    public void setBombaViva(boolean bombaViva) {
        this.bombaViva = bombaViva;
    }

    public boolean isExplodindo() {
        return explodindo;
    }

    public void setExplodindo(boolean explodindo) {
        this.explodindo = explodindo;
    }

    public Image getExplosao() {
        return explosao;
    }

    public void setExplosao(Image explosao) {
        this.explosao = explosao;
    }

    public int getTempoDeExplosao() {
        return tempoDeExplosao;
    }

    public void setTempoDeExplosao(int tempoDeExplosao) {
        this.tempoDeExplosao = tempoDeExplosao;
    }

    public int getTempoDeVidaDaBomba() {
        return tempoDeVidaDaBomba;
    }

    public void setTempoDeVidaDaBomba(int tempoDeVidaDaBomba) {
        this.tempoDeVidaDaBomba = tempoDeVidaDaBomba;
    }

    public boolean isExplodida() {
        return explodida;
    }

    public void setExplodida(boolean explodida) {
        this.explodida = explodida;
    }

}
